﻿package tuio 
{
	import flash.events.EventDispatcher; 
	
	/**
	 * @class TUIOEventWatcher.as
	 * @namespace tuio
	 * @author Niqui Merret
	 * @version 1.0
	 * @date May 26, 2008
	 * @description
	 * @usage
	 * NOTE:
	 * TODO:
	 *
	 */
	public class TUIOEventWatcher extends EventDispatcher 
	{

		private var tuioObjectList : Array;
		private var tuioObjectListCounter : Array;
		private var currentIDs : Array;
		private var activeIDs : Array;
		private static var mInstance : TUIOEventWatcher;
		private static var allowInst : Boolean;

		public function TUIOEventWatcher()
		{
			if (!allowInst) {
	            throw new Error("Error: Instantiation failed: Use TouchEventsManager.getInstance() instead of new.");
	          }
	          else
	          {
	          	tuioObjectList = new Array();
				tuioObjectListCounter = new Array();
				currentIDs = new Array();
				activeIDs = new Array();
	          }
			
		}
			
		public static function getInstance():TUIOEventWatcher
		{
			
			if (mInstance == null)
			{
            	allowInst = true;
				mInstance = new TUIOEventWatcher();
				allowInst = false;	
			}
			return mInstance;
			
		}
		
	/*********************************************************************************************
	 * public 
	 *********************************************************************************************/
	
		
		public function addTUIOObj (pTuioobj : TUIOObject) : void
		{
			
			var i : uint;
			var len : uint = tuioObjectList.length;
			
			for (i = 0; i< len; i++)
			{
				if (tuioObjectList[i] == pTuioobj)
				{
					return;
					
				}
			}
			tuioObjectList.push(pTuioobj);
			tuioObjectListCounter.push(0);
			activeIDs.push(pTuioobj.ID);
			cleanUpEvents();
			
		}
		
		public function removeTUIOObj (pTuioobj : TUIOObject) : void
		{
			var i : uint;
			var len : uint = tuioObjectList.length;
			
			for (i = 0; i< len; i++)
			{
				if (tuioObjectList[i] == pTuioobj)
				{
					tuioObjectList.splice(i, 1);
					tuioObjectListCounter.splice(i, 1);
					
				}
			}
					
		}
		
		public function cleanUpEvents () : void
		{
			
			//trace("cleanUpEvents");
			
			var i : uint;
			var len : uint = tuioObjectList.length;
			
			var j : uint;
			var lenj : uint = activeIDs.length;
			
			var matched : Boolean = false;
			
					
					
			for (i = 0; i< len; i++)
			{
				for (j = 0; j< lenj; j++)
				{
					if (tuioObjectList[i].ID == activeIDs[j])
					{
						tuioObjectListCounter[i] = 0;
						matched = true;
					}
				}
					
				if (!matched)
				{
					tuioObjectListCounter[i]++;
				}
				matched = false;
			}
			
			activeIDs = [];
			
			//
			len = tuioObjectListCounter.length;
			
			for (i = 0; i< len; i++)
			{
				if (tuioObjectListCounter[i] > 5)
				{
					
					tuioObjectList[i].kill();
					tuioObjectList.splice(i, 1);
					tuioObjectListCounter.splice(i, 1);
				}
			}
			
			
		}
		
	}
}
